/*
 * This is free software; you can redistribute it and/or modify it
 * under the terms of the GNU General Public License as published by
 * the Free Software Foundation; either version 2 of the License, or
 * (at your option) any later version.
 *
 * This code is distributed in the hope that it will be useful, but
 * WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
 * General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with this code; if not, write to the Free Software
 * Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA
 * 02111-1307, USA.  */

/* Copyright (C) 2002 Ian Zimmerman <itz@speakeasy.org> */

#ifndef INCLUDE_GIM_REGION_HH
#define INCLUDE_GIM_REGION_HH

/* $Id: gim_region.hh,v 1.1 2002/08/26 08:39:35 itz Exp $ */

#ifdef __cplusplus

extern "C" {
#include <libgim/gim_public.h>
}

#include <libgim/gim_abstract_handler.hh>

class gim_region : public gim_abstract_handler {
public:
  gim_region(int x_min, int x_max, int y_min, int y_max,
                     unsigned min_mod, unsigned max_mod,
                     enum gim_event_kind_t handle);
  void put(gim_region* after);
private:
  struct gim_region_t reg;
  virtual int object_handler(struct gim_event_t*);
  virtual int region_handler(struct gim_event_t*) = 0;
  static int static_handler(struct gim_event_t* p_ev, struct gim_handler_data_t* hdata);
};

#endif // __cplusplus

#endif // INCLUDE_GIM_REGION_HH
